
#include <errno.h>

/* C shifts may not work if the amount is greater than the machine word size */
/* Patched by JAR 6/6/93 */

#define PS_SHIFT_RIGHT(X,Y,RESULT)   \
{                                    \
  long TTx = X,  TTy = Y;            \
  RESULT = TTy >= 32 ? (TTx < 0 ? -1 : 0) : TTx >> TTy; \
}  

#define PS_SHIFT_LEFT(X,Y,RESULT)    \
{                                    \
  long TTy = Y;                      \
  RESULT = TTy >= 32 ? 0 : X << TTy; \
}  

#define PS_SMALL_MULTIPLY(x,y) ((x) * (y))

extern long TTreturn_value, TTrun_machine();

extern int ps_open(unsigned char *, char *);
extern unsigned char ps_close(int);
extern long ps_read(int, void *, long, unsigned char *, unsigned char *);
extern long ps_write(int, void *, long, unsigned char *);
extern void ps_write_string(char *, int);

#include <unistd.h>

extern int ps_select(fd_set *, fd_set *, fd_set *, long);
extern long ps_read_time();
extern long ps_run_time();
extern long ps_clock_tick();
extern long ps_clock_exponent();
