; Copyright (c) 1993, 1994 Richard Kelsey and Jonathan Rees.  See file COPYING.


(define (adjoin-bits high low k)
  (+ (ashl high k) low))

(define (low-bits n k)
  (bitwise-and n (- (ashl 1 k) 1)))

(define high-bits ashr)

(define unsigned-high-bits lshr)

(define (digit? ch)
  (let ((ch (char->ascii ch)))
    (and (>= ch (char->ascii #\0))
	 (<= ch (char->ascii #\9)))))

(define (vector+length-fill! v length x)
  (do ((i 0 (+ i 1)))
      ((>= i length))
    (vector-set! v i x)))
